--[[
						  PtokaX.  1.6.

	-        PtokaX.
	-    .
	-      ,         .
	-   , www  wWw   (          cp1251   ).
	-           (    ,          ).
	-        .
	-       (        ).
	-      :      (  ),  (     disconnect),     (    ,    ),   ( ,      ,         )       .
	-           (  ,   ).
	-       ,    .
	-    - (tProfiles)   .
	-       .

	    ,       lua.

	!       old_api.lu.

            :  Damaks     nd
			:  1.6
            :     GOLD-HUB:  dchub://goldhub.mydc.ru     dchub://10.170.161.189
            :    http://rsload.net/
			 :	http://mydc.ru/topic3516.html
            :  PtokaX 0.3.5-0.3.6,  Lua 5.1,   API1
]]


-------------------------------[ Preference ]-------------------------------

if frmHub then dofile(frmHub:GetPtokaXLocation().."scripts/old_api.lu") elseif not Core then error("      !",2) else dofile(Core.GetPtokaXPath().."scripts/old_api.lu") end

local sBot = ''      --  
local bot_reg = 1      --      (1 - , 0 - )
local ban_time = 10      --   ()
local op_info = 1      --          (1 - , 0 - )
local min_size = 8      --   ,    

local tProfiles = {      --  ,     (1 - ; 0 - )
   [0] = 1,      -- 
   [1] = 1,      -- 
   [2] = 1,      -- VIP
   [3] = 0,      --  
  [-1] = 0,      --  
}

local block_all_mode = 2     --[[      :
                                   0 -    ,    BanTime;
                                   1 - ;
                                   2 -   block_message[1];
                                   3 -   (   ).
                                   4 -   (   ,      .
]]
local block_pm_mode = 2       --[[     :
                                   0 -    ,    BanTime;
                                   1 - ;
                                   2 -    block_message[1]    ;
                                   3 -   (   ).
                                   4 -   (   ,      ).
]] 

local forbidden_patterns = {      --   
	'd.?c.?h.?u.?b.?:.?/.?/', 'd%p*c%p*h%p*u%p*b%p*:%p*/%p*/', 'd%s*c%s*h%s*u%s*b%s*:%s*/%s*/',		--  "dchub://"  
	'h.?t.?t.?p.?:.?/.?/', 'h%p*t%p*t%p*p%p*:%p*/%p*/', 'h%s*t%s*t%s*p%s*:%s*/%s*/',		--  "http://"  
	'w.?w.?w.?%.',		--  "www."  
	'no%s?%-%s?ip', '%-%s?hub%s?%.%s?org', 'dyndns%s?%.%s?tv', '%.%s?ucoz%s?%.',		--   ""    (*no-ip*, *-hub.org*, *dyndns.tv, *.ucoz.*)
	'%d+%.%d+%.%d+%.%d+',		--  ip-
	'%a%.ro%:?%d*%s+', '%a%.ro%:?%d*$', '%a%.ro%:?%d*/',		--  .ro
	'%a%.ru%:?%d*%s+', '%a%.ru%:?%d*$', '%a%.ru%:?%d*/',		--  .ru
	'%a%.ua%:?%d*%s+', '%a%.ua%:?%d*$', '%a%.ua%:?%d*/',		--  .ua
	'%a%.net%:?%d*%s+', '%a%.net%:?%d*$', '%a%.net%:?%d*/',		--  .net
	'%a%.com%:?%d*%s+', '%a%.com%:?%d*$', '%a%.com%:?%d*/',		--  .com
}

local allowed_patterns = {      --   
	'magnet:%?xt%S*',      --    -
	'%S*wikipedia%.org%S*%s*', '%S*youtube%.com%S*%s*', '%S*rutube%.ru%S*%s*', '%S*smotri%.com%S*%s*',  '%S*radikal%.ru%S*%s*',  '%S*fastpic%.ru%S*%s*',  '%S*rghost%.ru%S*%s*',      --   
	'%S*rsload%.net%S*%s*', '%S*forum%.rsload%.net%S*%s*', '%S*95%.141%.193%.17%S*%s*',
	'%S*goldhub%.mydc.ru%S*%s*', '%S*89%.222%.185%.103%S*%s*', '%S*10.170.161.189%S*%s*',      --     ip
}

local block_message = {      --  
	'!        !',
	'!        !     ',
	'!        !   .',
	'     :   ',
	'        ',
}


------------------------------[ Code Section ]------------------------------


function Core.OnStartup()
	if bot_reg==1 then
		Core.RegBot(sBot,'','',true)
	end
end

--     cp1251   

function string.lower2(message)
    return message:gsub('([-])',
		function(str)
			return string.char(str:byte()+32)
		end):gsub('', ''):lower()
end

--  , ,   ,            (captures)

local function gfind_patterns(string_, patterns)
	return coroutine.wrap(function ()
	for _, pattern in ipairs(patterns) do
		local i = 1
		while true do
			local results = {string_:find(pattern, i)}
			if not results[1] then
				break
			end
			i = results[2] + 1
			coroutine.yield(unpack(results))
		end
	end
	end)
end

-- ""         

local function collect_results(iterator)
	local all_results = {}
	while true do
		local results = {iterator()}
		if not results[1] then
			break
		end
		table.insert(all_results, results)
	end
	return all_results
end

--  true       forbidden_patterns     allowed_patterns,   false

local function is_forbidden(message, forbidden_patterns, allowed_patterns)
	local allowed_indexes
	for start, end_ in gfind_patterns(message, forbidden_patterns) do
		if not allowed_indexes then
			allowed_indexes = collect_results(gfind_patterns(message, allowed_patterns))
		end
		local forbid = true
		for _, indexes in ipairs(allowed_indexes) do
			if start >= indexes[1] and end_ <= indexes[2] then
				forbid = false
				break
			end
		end
		if forbid then
			return true
		end
	end
	return false
end

--     

function Core.ChatArrival(user,data)
	local message = data:match('%b<>%s*(.+)|$')
	if message and tProfiles[user.iProfile]==0 then
		if #message >= min_size then
			message = string.lower2(message)
			if is_forbidden(message, forbidden_patterns, allowed_patterns) then
				if op_info==1 then
					Core.SendPmToOps(sBot, ('***  ['..user.sIP ..'] '..user.sNick..block_message[4]..message))
				end
				if block_all_mode==0 then
					Core.SendToUser(user,'<'..sBot..'> *** '..block_message[2]..ban_time..' .')
					BanMan.TempBan(user,ban_time,'','',false)
					return true
				end
				if block_all_mode==1 then
					Core.SendToUser(user,'<'..sBot..'> ***  '..block_message[3])
					Core.Disconnect(user)
					return true
				end
				if block_all_mode==2 then
					Core.SendToUser(user, '<'..sBot..'> ***  '..block_message[1])
					return true
				end
				if block_all_mode==3 then
					Core.SendToUser(user, ('<%s> %s'):format(user.sNick, message))    
					return true
				end
					if block_all_mode==4 then
				end
			end
		end
	end
	return false
end

--     

function Core.ToArrival(user,data)
	local message = data:match('%b<>%s*(.+)|$')
	local s,e,to,from,sNick,message = string.find(data, '%$To:%s(%S+)%sFrom:%s(%S+)%s$<(%S+)%>%s(.*)$')
	local tToUser = Core.GetUser(to)
	if tToUser and message and tProfiles[user.iProfile]==0 and tProfiles[tToUser.iProfile]==0 then
		message = string.lower2(message)
		if is_forbidden(message, forbidden_patterns, allowed_patterns) then
			if op_info==1 then
				Core.SendPmToOps(sBot, ('***  ['..user.sIP ..'] '..user.sNick..block_message[5]..'['..tToUser.sIP ..'] '..to..'  :  '..message))
			end
			if block_pm_mode==0 then
				Core.SendPmToUser(user, sBot,'***  '..block_message[2]..ban_time..' .')
				BanMan.TempBan(user,ban_time,'','',false)
				return true
			end
			if block_pm_mode==1 then
				Core.SendPmToUser(user, sBot,'***  '..block_message[3])
				Core.Disconnect(user)
				return true
			end
			if block_pm_mode==2 then
				Core.SendPmToUser(user, sBot,'***  '..block_message[1])
				return true
			end
			if block_pm_mode==3 then
				return true
			end
			if block_pm_mode==4 then
			end
		end
	end
	return false
end
